-- This Source Code Form is subject to the terms of the bCDDL, v. 1.1.
-- If a copy of the bCDDL was not distributed with this
-- file, You can obtain one at http://beamng.com/bCDDL-1.1.txt

local M = {}
M.type = "auxiliary"
M.relevantDevice = nil

local htmlTexture = require("htmlTexture")

local min = math.min
local max = math.max

local gaugesScreenName = nil
local htmlPath = nil

local updateFPS = 30

local distanceTotalm = 0

local function updateGFX(dt)
    local data = {}

    data.dategauge = os.date("%d") .. " " .. string.upper(os.date("%b")) .. " " .. os.date("%Y") .. " " .. os.date("%H") .. ":" .. os.date("%M")
	
	data.speedometergauge = electrics.values["wheelspeed"] * 3.6
	data.rpm = electrics.values["rpm"]
	data.enginerunning = electrics.values["engineRunning"]
	
	data.signal_l = electrics.values["signal_L"]
	data.signal_r = electrics.values["signal_R"]
	data.lowfuel = electrics.values["lowfuel"]
	data.battery = electrics.values["battery"]
	
	data.fuel = electrics.values["fuel"]
	data.watertemp = electrics.values["watertemp"]
	
	data.kneel = electrics.values["kneel"]
	data.doorlever = electrics.values["doorLever"]
	data.wheelchairramp = electrics.values["wheelchairramp"]
	data.enginedoor = electrics.values["enginedoor"]
	
	distanceTotalm = distanceTotalm + electrics.values.wheelspeed * dt
	electrics.values["odometer"] = math.floor(distanceTotalm / 100) / 10
	data.odometer =  electrics.values["odometer"]
	
    data.topscreenunit = electrics.values["screenunit"]

    --dump(data)
    htmlTexture.call(gaugesScreenName, "updateData", data)
    updateTimer = 0
end

local function init(jbeamData)
	gaugesScreenName = jbeamData.materialName
	htmlPath = jbeamData.htmlPath
	local width = jbeamData.textureWidth or 512
	local height = jbeamData.textureHeight or 256

    htmlTexture.create(gaugesScreenName, htmlPath, width, height, updateFPS, "automatic")
	htmlTexture.call(gaugesScreenName, "setUnits", {unitType = unitType})
	
	electrics.values["odometer"] = 0
end

M.init = init
M.updateGFX = updateGFX

return M
