angular.module('gaugesScreen', [])
.controller('GaugesScreenController', function($scope, $window) {
  var unit = null;
  $scope.data = {}
  // overwriting plain javascript function so we can access from within the controller
  $window.setUnits = (data) => {
    unit = data.unitType;
  }
  
  $window.updateData = (data) => {
    $scope.$evalAsync(function() {

		const div = document.getElementById("dategauge");
		const sigl = document.getElementById("signal_l");
		const sigr = document.getElementById("signal_r");
		const fuel = document.getElementById("lowfuel");
		const bat = document.getElementById("battery");
		const remindcolour = "#CC9900"
		const needledef = "url(/vehicles/common/capsule/gauges/capsule_gauges_needle.png)"
		const needlered = "url(/vehicles/common/capsule/gauges/capsule_gauges_needle_red.png)"
		const needleblue = "url(/vehicles/common/capsule/gauges/capsule_gauges_needle_blue.png)"
		var speedang
		var rpmang = parseInt(-180/3200*data.rpm)
		if (rpmang < -180) {rpmang = -180}
		var fuelang = parseInt(90*data.fuel)
		var tempang = parseInt(-90*((data.watertemp*9/5+32)-90)/180)
		var pressang = parseInt(-90*55/100)
		var batang = parseInt(90*(24-16)/20)
		
        if (data.enginerunning != 0 ) {
		$scope.data.speedometergauge = (data.speedometergauge * 0.621371).toFixed(0)
		speedang = parseInt(180/100*$scope.data.speedometergauge)
		if (speedang > 180) {speedang = 180}
		document.getElementById("speed").style.transform = "rotate(" + speedang + "deg)";
		document.getElementById("speedbar").style.transform = "rotate(" + (speedang-135) + "deg)";
		document.getElementById("rpm").style.transform = "rotate(" + rpmang + "deg)";
		document.getElementById("rpmbar").style.transform = "rotate(" + (rpmang+45) + "deg)";
		document.getElementById("fuelneedle").style.transform = "rotate(" + fuelang + "deg)";
		document.getElementById("fuelbar").style.transform = "rotate(" + (fuelang-45) + "deg)";
		if (data.fuel <= 0.1) {
			document.getElementById("fuelneedle").style.backgroundImage = needlered;
			document.getElementById("fuelbar").style.borderLeftColor = "rgba(204,51,0,0.2)";
		} else {
			document.getElementById("fuelneedle").style.backgroundImage = needledef;
			document.getElementById("fuelbar").style.borderLeftColor = "rgba(105,94,152,0.2)";
		}
		document.getElementById("tempneedle").style.transform = "rotate(" + (tempang+180) + "deg)";
		document.getElementById("tempbar").style.transform = "rotate(" + (tempang+225) + "deg)";
		if (data.watertemp >= 100) {
			document.getElementById("tempneedle").style.backgroundImage = needlered;
			document.getElementById("tempbar").style.borderLeftColor = "rgba(204,51,0,0.2)";
		} else if (data.watertemp <= 60) {
			document.getElementById("tempneedle").style.backgroundImage = needleblue;
			document.getElementById("tempbar").style.borderLeftColor = "rgba(51,102,255,0.2)";
		} else {
			document.getElementById("tempneedle").style.backgroundImage = needledef;
			document.getElementById("tempbar").style.borderLeftColor = "rgba(105,94,152,0.2)";
		}
		document.getElementById("pressneedle").style.transform = "rotate(" + (pressang) + "deg)";
		document.getElementById("pressbar").style.transform = "rotate(" + (pressang+45) + "deg)";
		document.getElementById("batneedle").style.transform = "rotate(" + (batang-180) + "deg)";
		document.getElementById("batbar").style.transform = "rotate(" + (batang-225) + "deg)";
			if (data.signal_l == 1 ) {sigl.style.visibility = "visible"} else {sigl.style.visibility = "hidden"}
			if (data.signal_r == 1 ) {sigr.style.visibility = "visible"} else {sigr.style.visibility = "hidden"}
			if (data.lowfuel == 1 ) {fuel.style.visibility = "visible"} else {fuel.style.visibility = "hidden"}
			if (data.battery == 1 ) {bat.style.visibility = "visible"} else {bat.style.visibility = "hidden"}
		div.style.color = "#FFFFFF";
		$scope.data.dategauge = data.dategauge
			if (data.kneel == 1 ) {div.style.color = remindcolour;$scope.data.dategauge = "BUS KNEELED"}
			if (data.doorlever == 1 ) {div.style.color = remindcolour;$scope.data.dategauge = "DOOR OPENED"}
			if (data.wheelchairramp == 1 ) {div.style.color = remindcolour;$scope.data.dategauge = "WCH RAMP OPENED"}
			if (data.enginedoor == 1 ) {div.style.color = remindcolour;$scope.data.dategauge = "ENGINE DOOR OPENED"}
		$scope.data.odometer = (data.odometer * 0.621371).toFixed(1) + " mi"
        }
		else {
		$scope.data.speedometergauge = " "
		$scope.data.dategauge = " "
		$scope.data.odometer = " "
		}

    }
	)
 }
});    